"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogUtils = void 0;
const pino_1 = __importDefault(require("pino"));
class LogUtils {
    constructor() {
        this.logger = pino_1.default();
    }
    debug(message, ...optionalParams) {
        this.logger.debug(message, optionalParams);
    }
    info(message, ...optionalParams) {
        this.logger.info(message, optionalParams);
    }
    log(message, ...optionalParams) {
        this.logger.log && this.logger.log(message, optionalParams);
    }
    warning(message, ...optionalParams) {
        this.logger.warn(message, optionalParams);
    }
    error(message, ...optionalParams) {
        this.logger.error(message, optionalParams);
    }
    getPino() {
        return this.logger;
    }
}
exports.LogUtils = LogUtils;
//# sourceMappingURL=LogUtils.js.map