"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResultUtils = void 0;
const neverthrow_1 = require("neverthrow");
class ResultUtils {
    static combine(asyncResultList) {
        return neverthrow_1.ResultAsync.fromPromise(Promise.all(asyncResultList), (e) => {
            return e;
        }).andThen(ResultUtils.combineResultList);
    }
    static combineResultList(resultList) {
        return resultList.reduce((acc, result) => {
            return acc.isOk()
                ? result.isErr()
                    ? neverthrow_1.err(result.error)
                    : acc.map((values) => {
                        values.push(result.value);
                        return values;
                    })
                : acc;
        }, neverthrow_1.ok([]));
    }
    static executeSerially(funcList) {
        // const results = new Array<T>();
        // // for (const func of funcList) {
        // //   func().map((val) => {})
        // // }
        // try {
        //   funcList.reduce(
        //     (p: ResultAsync<void, E>, x) =>
        //       p.andThen(_ => {
        //         return x()
        //           .map((result) => {
        //             results.push(result);
        //           })
        //           .mapErr((e) => {
        //             throw e;
        //           });
        //       }),
        //     okAsync<void, E>(undefined)
        //   );
        // }
        // catch (e) {
        //   return errAsync(e);
        // }
        const func = () => __awaiter(this, void 0, void 0, function* () {
            const results = new Array();
            for (const func of funcList) {
                const result = yield func();
                if (result.isErr()) {
                    throw result.error;
                }
                else {
                    results.push(result.value);
                }
            }
            return results;
        });
        return neverthrow_1.ResultAsync.fromPromise(func(), (e) => {
            return e;
        });
    }
}
exports.ResultUtils = ResultUtils;
//# sourceMappingURL=ResultUtils.js.map